Attribute VB_Name = "Module1"
Option Explicit

Global Const StartUpDirPath = "c:\svserver"

Global Const MAXLines = 4
Global Const KEY_ESCAPE = &H1B

Global Const IDLE = 0
Global Const COMMAND = 1
Global Const NOTIFIED = 2
Global Const DATA_READY = 3

Global Const DV_TPT_TYPE = 1
Global Const DX_IOTT_TYPE = 2
Global Const DX_CAP_TYPE = 3
Global Const TN_GEN_TYPE = 4

Global Const STATUS_FUNCTION_NONE = 0
Global Const STATUS_FUNCTION_READY = 1
Global Const STATUS_FUNCTION_RUNNING = 2
Global Const STATUS_FUNCTION_NOTIFIED = 3
Global Const STATUS_FUNCTION_COMPLETE = 4

Type DDELinkType
    LineNo As Integer
    Function As Integer
    Status As Integer
    Error As Integer
    Return As Long
    Result As String * 128
End Type

Type TheEventType
    LineNo As Integer
    Device As Integer
    Type As Integer
    CSTEvent As Integer
    CSTData As Integer
End Type

Type LineDataType
    Process As Integer
    NextStep As Integer
    DeviceHandle As Integer
    LineString As String * 16
    SuccessiveErrors As Integer
    AbortProcess As Integer
    ExitProcess As Integer
End Type

Type CFGFileDataType
    CFGLineSelect As Integer
    CFGDialogicFilePath As String * 128
    CFGSVServerFilePath As String * 128
    CFGCaptureTextToFile As Integer
End Type

Global LineData(MAXLines) As LineDataType
Global LinkResult(MAXLines) As DDELinkType

Global PassFilePath As String * 128
Global PassFilePattern As String * 16
    
Global CFGFileNo As Integer
Global CFGFileName As String
Global CFGFilePath As String
Global CFGFileData As CFGFileDataType
Global CFGTempData As CFGFileDataType

Global TXTFileNo As Integer
Global TXTFileName As String
Global TXTFilePath As String

Global CMDFileNo As Integer
Global CMDFileName As String
Global CMDFilePath As String

Global Const MB_OK = 0                 ' OK button only
Global Const MB_OKCANCEL = 1           ' OK and Cancel buttons
Global Const MB_ABORTRETRYIGNORE = 2   ' Abort, Retry, and Ignore buttons
Global Const MB_YESNOCANCEL = 3        ' Yes, No, and Cancel buttons
Global Const MB_YESNO = 4              ' Yes and No buttons
Global Const MB_RETRYCANCEL = 5        ' Retry and Cancel buttons

Global Const IDYES = 6
Global Const IDNO = 7

'Global Const SR_POLLMODE = 0            ' Run SRL in polling mode
'Global Const SR_MODEID = &H2            ' Set SRL running in signalling or DOS mode
'Global Const SRL_DEVICE = 0             ' The SRL device

'Values for setting hook state
 
Global Const DL_ONHOOK = 0
Global Const DL_OFFHOOK = 1

Function LoadFileData() As Integer
    Dim Ndx As Integer

    On Error Resume Next

    '   Load Confiuration File

    Err = 0
    LoadFileData = True
    Open CFGFilePath For Random Access Read Write As CFGFileNo Len = Len(CFGFileData)
    If Err = 0 Then
        If LOF(CFGFileNo) > 0 Then
            Get #CFGFileNo, 1, CFGFileData
            CFGTempData = CFGFileData
        Else
            CFGTempData.CFGLineSelect = 0
            CFGTempData.CFGDialogicFilePath = "c:\users\dialogic\bin\startcfg.exe"
            CFGTempData.CFGSVServerFilePath = StartUpDirPath & "\svserver.exe"
            CFGTempData.CFGCaptureTextToFile = False
        End If
        Close CFGFileNo
    Else
        MsgBox "Open Error " & Str$(Err) & " , Configuration File Path = " & CFGFilePath
        LoadFileData = False
    End If
End Function




    

Sub CenterForm(TheForm As Form)

    On Error Resume Next

    TheForm.Left = (Screen.Width - TheForm.Width) / 2
    TheForm.Top = (Screen.Height - TheForm.Height) / 2
    
    DoEvents
    
End Sub

Public Sub SaveFileData()

    On Error Resume Next

    Open CFGFilePath For Random Access Write As CFGFileNo Len = Len(CFGFileData)
    CFGFileData = CFGTempData
    Put #CFGFileNo, 1, CFGFileData
    Close CFGFileNo
End Sub




Public Function ShellDialogic(AppFilePath As String) As Integer
    Dim Result
    
    On Error Resume Next
    
    '   Launch maximized with focus
    
    Err = 0
    Result = Shell(AppFilePath, 1)
    ShellDialogic = Err
    
End Function

Public Function ShellSVServer(AppFilePath As String) As Integer
    Dim Result
    
    On Error Resume Next
    
    '   For one thread per line for synchronous operation
    '   use the term "MultiThread" in the shell launch command.
    '   MaxLines nn is not being used to limit the number of lines
    '   Result = Shell(Trim$(AppFilePath) & " SVSLicense, MultiThread, MaxLines 1", 1)
    
    Err.Clear
    Result = Shell(Trim$(AppFilePath) & " SVSLicense, MultiThread", 1)
    ShellSVServer = Err.Number
    MsgBox "The SVSERVER.EXE will not operate with SVSLicense... A valid authorization code is embedded in the executables.  Please run the sample applications in the EXECUTES folder.", MB_OK, ""
    
End Function

Public Sub ShellNotes()
    Dim Result As Variant
    Dim FilePath As String * 128

    On Error Resume Next

    FilePath = "notepad.exe " & StartUpDirPath & "\svssamp2\infosht2.txt"
    Result = Shell(Trim$(FilePath), 1)
    DoEvents

End Sub


Public Sub ShellTextFile()
    Dim Result As Variant
    Dim FilePath As String * 128

    On Error Resume Next

    FilePath = Trim$("notepad.exe " & StartUpDirPath & "\svssamp2\svssamp2.txt")
    Result = Shell(Trim$(FilePath), 1)
    DoEvents
End Sub





Public Function CutText() As Integer
    Dim Result As Integer
    Dim EditString As String, String1 As String, String2 As String
    Dim LenEditString As Integer, LenString1 As Integer, LenString2 As Integer

    On Error Resume Next

    Result = CopyText()
    If Result = True Then
        LenEditString = Len(Trim$(Screen.ActiveControl.Text))
        EditString = Trim$(Screen.ActiveControl.Text)

        LenString1 = Screen.ActiveControl.SelStart
        String1 = Trim$(Left$(Screen.ActiveControl.Text, LenString1))
        
        LenString2 = LenEditString - (LenString1 + Screen.ActiveControl.SelLength)
        String2 = Trim$(Right$(EditString, LenString2))

        Screen.ActiveControl.Text = Trim$(String1) & Trim$(String2)
    Else
        Result = False
    End If
    CutText = Result
End Function
Public Function CopyText() As Integer
    Dim Result As Integer
    Dim EditString As String

    On Error Resume Next

    Result = False

    If TypeOf Screen.ActiveControl Is TextBox Then Result = True
    If TypeOf Screen.ActiveControl Is ComboBox Then
        If Screen.ActiveControl.Style <> 2 Then Result = True
    End If
    If Result = True Then
        EditString = Trim$(Mid$(Screen.ActiveControl.Text, Screen.ActiveControl.SelStart + 1, Screen.ActiveControl.SelLength))
        Clipboard.SetText EditString
    End If
    CopyText = Result
End Function



Public Function PasteText()
    Dim Result As Integer
    Dim EditString As String, String1 As String, String2 As String, String3 As String
    Dim LenEditString As Integer, LenString1 As Integer, LenString2 As Integer, LenString3 As Integer

    On Error Resume Next

    Result = False

    If TypeOf Screen.ActiveControl Is TextBox Then Result = True
    If TypeOf Screen.ActiveControl Is ComboBox Then
        If Screen.ActiveControl.Style <> 2 Then Result = True
    End If
    If Result = True Then
        LenEditString = Len(Trim$(Screen.ActiveControl.Text))
        EditString = Trim$(Screen.ActiveControl.Text)

        LenString1 = Screen.ActiveControl.SelStart
        String1 = Trim$(Left$(Screen.ActiveControl.Text, LenString1))
        
        String2 = Trim$(Clipboard.GetText(1))
        LenString2 = Len(String2)

        LenString3 = LenEditString - (LenString1 + Screen.ActiveControl.SelLength)
        String3 = Trim$(Right$(EditString, LenString3))

        Screen.ActiveControl.Text = Trim$(String1) & Trim$(String2) & Trim$(String3)
    Else
        Result = False
    End If
    PasteText = Result
End Function


Public Sub EditMenuEnable()

    On Error Resume Next

    Screen.ActiveForm.CutItem.Enabled = True
    Screen.ActiveForm.CopyItem.Enabled = True
    Screen.ActiveForm.PasteItem.Enabled = True

End Sub


    Public Sub EditMenuDisable()

    On Error Resume Next

    Screen.ActiveForm.CutItem.Enabled = False
    Screen.ActiveForm.CopyItem.Enabled = False
    
End Sub






Public Sub ShellFunctionSet()
    Dim Result As Variant
    Dim FilePath As String * 128

    On Error Resume Next
    
    FilePath = "write.exe " & StartUpDirPath & "\functset.doc"
    Result = Shell(FilePath, 3)
    'MsgBox Trim$(FilePath)
    DoEvents
    
End Sub

Public Sub LoadCommands(FilePath As String)
    Dim LenOfText As Long
    
    On Error Resume Next
    
    LenOfText = FileLen(FilePath)

    If LenOfText > 0 Then
        Err.Clear
        Open FilePath For Input As CMDFileNo
        If Err.Number = 0 Then
            Form1.Text5.Text = ""
            Form1.Text5.Text = Trim$(Input$(LenOfText, CMDFileNo))
        End If
        Close CMDFileNo
    End If
    
End Sub

Public Sub SaveCommands(FilePath As String)
    Dim LenOfText As Integer
    
    On Error Resume Next

    LenOfText = Len(Trim$(Form1.Text5.Text))

    If LenOfText > 0 Then
        Kill FilePath
        Open FilePath For Binary As CMDFileNo
        Put CMDFileNo, , Form1.Text5.Text
        Close CMDFileNo
    End If
    
End Sub

Public Sub StripSpaces(InString As String, OutString As String)
    Dim Ndx As Integer, Max As Integer, Index As Integer, InChr As Integer
    
    On Error Resume Next
    
    Index = 1

    Max = Len(Trim$(InString))
    
    For Ndx = 1 To Max Step 1
        InChr = Asc(Mid$(InString, Ndx, 1))
        If InChr > 32 Then
            Mid$(OutString, Index, 1) = Mid$(InString, Ndx, 1)
            Index = Index + 1
        End If
    Next Ndx
    
End Sub

Public Sub ShellOrderForm()
    Dim Result As Variant
    Dim FilePath As String * 128

    On Error Resume Next
    
    FilePath = "write.exe " & StartUpDirPath & "\svsorder.wri"
    Result = Shell(FilePath, 3)
    DoEvents
    
End Sub
