Attribute VB_Name = "Module1"
Option Explicit

Global Const StartUpDirPath = "c:\svserver"

'   THE EVALUATION SOFTWARE IS LIMITED TO
'   2 LINES AND 48 FUNCTION EXECUTIONS IN SVSERVER

Global Const MAXLines = 2   '   if you change this to a smaller value,
                            '   be sure to use the MaxLines feature in
                            '   sub-routine ShellSVServer to limit the
                            '   number of threads started in SVServer
                
Global Const IDLE = 0
Global Const WAITING = 1
Global Const NOTIFIED = 2
Global Const DATA_READY = 3

Global Const DV_TPT_TYPE = 1
Global Const DX_IOTT_TYPE = 2
Global Const DX_CAP_TYPE = 3
Global Const TN_GEN_TYPE = 4

Global Const STATUS_FUNCTION_NONE = 0
Global Const STATUS_FUNCTION_READY = 1
Global Const STATUS_FUNCTION_RUNNING = 2
Global Const STATUS_FUNCTION_NOTIFIED = 3
Global Const STATUS_FUNCTION_COMPLETE = 4

Type DDELinkType
    LineNo As Integer
    Function As Integer
    Status As Integer
    Error As Integer
    Return As Long
    Result As String * 128
End Type

Type TheEventType
    LineNo As Integer
    Device As Integer
    Type As Integer
    CSTEvent As Integer
    CSTData As Integer
End Type

Type LineDataType
    Process As Integer
    NextStep As Integer
    DeviceHandle As Integer
    LineString As String * 16
    SuccessiveErrors As Integer
    AbortProcess As Integer
    ExitProcess As Integer
End Type

Type CFGFileDataType
    CFGApplicationText(4) As String * 128
    CFGSSCheckBox1(3) As Integer
    CFGSSCheckBox2(2) As Integer
    CFGPhoneNumber(2) As String * 20
    CFGCaptureTextToFile As Integer
End Type

Global LineData(MAXLines) As LineDataType
Global LinkResult(MAXLines) As DDELinkType
Global EventResult(MAXLines) As TheEventType

Global PassFilePath As String * 128
Global PassFilePattern As String * 16
    
Global CFGFileNo As Integer
Global CFGFileName As String
Global CFGFilePath As String
Global CFGFileData As CFGFileDataType
Global CFGTempData As CFGFileDataType

Global TXTFileNo As Integer
Global TXTFileName As String
Global TXTFilePath As String

Global Const MB_OK = 0                 ' OK button only
Global Const MB_OKCANCEL = 1           ' OK and Cancel buttons
Global Const MB_ABORTRETRYIGNORE = 2   ' Abort, Retry, and Ignore buttons
Global Const MB_YESNOCANCEL = 3        ' Yes, No, and Cancel buttons
Global Const MB_YESNO = 4              ' Yes and No buttons
Global Const MB_RETRYCANCEL = 5        ' Retry and Cancel buttons

Global Const SR_POLLMODE = 0            ' Run SRL in polling mode
Global Const SR_MODEID = &H2            ' Set SRL running in signalling or DOS mode
Global Const SRL_DEVICE = 0             ' The SRL device

'Values for setting hook state
 
Global Const DL_ONHOOK = 0
Global Const DL_OFFHOOK = 1
'Global Const DX_ONHOOK = 0
'Global Const DX_OFFHOOK = 1

'       Define Event Types

Global Const TDX_PLAY = &H81           ' Play Completed
Global Const TDX_RECORD = &H82         ' Record Completed
Global Const TDX_GETDIG = &H83         ' Get Digits Completed
Global Const TDX_DIAL = &H84           ' Dial Completed
Global Const TDX_CALLP = &H85          ' Call Progress Completed
Global Const TDX_CST = &H86            ' CST Event Received
Global Const TDX_SETHOOK = &H87        ' SetHook Completed
Global Const TDX_WINK = &H88           ' Wink Completed
Global Const TDX_PLAYTONE = &H8A       ' Play Tone Completed
Global Const TDX_GETR2MF = &H8B        ' Get R2MF completed

Global Const TDX_ERROR = &H89          ' Error Event
Global Const DX_ATOMIC_ERR = &HEE      ' Error event for Atomic Funcs

'D/4X Events and masks
 
Global Const DE_RINGS = 1        ' Rings received
Global Const DE_SILON = 2        ' Silence on
Global Const DE_SILOF = 3        ' Silenec off
Global Const DE_LCON = 4         ' Loop current on
Global Const DE_LCOF = 5         ' Loop current off
Global Const DE_WINK = 6         ' Wink received
Global Const DE_RNGOFF = 7       ' Ring off event
Global Const DE_DIGITS = 8       ' Digit Received
Global Const DE_DIGOFF = 9       ' Digit tone off event
Global Const DE_LCREV = 13       ' Loop current reversal
Global Const DE_TONEON = 17      ' Tone ON  Event Received
Global Const DE_TONEOFF = 18     ' Tone OFF Event Received
Global Const DE_STOPRINGS = 19   ' Stop ring detect state

Global Const DM_RINGS = 1      ' ( 1 << (DE_RINGS - 1) )
Global Const DM_SILON = 2      ' ( 1 << (DE_SILON - 1) )
Global Const DM_SILOFF = 4     ' ( 1 << (DE_SILOF - 1) )
Global Const DM_LCON = 8       ' ( 1 << (DE_LCON - 1) )
Global Const DM_LCOFF = 16     ' ( 1 << (DE_LCOF - 1) )
Global Const DM_LCREV = 4096   ' ( 1 << (DE_LCREV - 1) )
Global Const DM_WINK = 32      ' ( 1 << (DE_WINK - 1) )
Global Const DM_RNGOFF = 64    ' ( 1 << (DE_RNGOFF - 1) )
Global Const DM_DIGITS = 128   ' ( 1 << (DE_DIGITS - 1) )
Global Const DM_DIGOFF = 256   ' ( 1 << (DE_DIGOFF - 1) )

'CHANNEL PARAMETERS

Global Const PM_BD = &H800000           ' Board Level Parameter
Global Const PM_CH = &H0                ' Channel Level Parameter

Global Const PM_DXXX = &H0              ' D/xxx Parameter
Global Const PM_D12X = &H1000000        ' D/12x Parameter
Global Const PM_MF40 = &H2000000        ' MF/40 Parameter
Global Const PM_D12XDEV = &H4000000

Global Const PM_FW = &H0                ' Firmware Parameter
Global Const PM_DRV = &H8000000         ' Driver Parameter
Global Const PM_LIB = &H10000000        ' Library Parameter

Global Const PRM_DEST = &H18000000
Global Const PRM_DEVTYP = &H7000000
Global Const PRM_DATTYP = &HE0000000
Global Const PRM_NUM = &HFFFF
Global Const PRM_TERM = &H7F0000

Global Const PM_BYTE = &H0              ' Byte
Global Const PM_SHORT = &H20000000      ' Short
Global Const PM_INT = &H40000000        ' Int
Global Const PM_LONG = &H60000000       ' Long
Global Const PM_VLSTR = &H80000000      ' Variable Length String
Global Const PM_FLSTR = &HA0000000      ' Fixed Length String

Global Const PM_VLSTR_MAXLEN = 128 ' Max Length for Variable Length Parms
 
' DTMF anti-talkoff during playback
'Global Const DXCH_DTMFTLK    ((PM_SHORT|PM_FW|PM_DXXX|PM_CH) | &H0101L)

' DTMF debounce time
'Global Const DXCH_DTMFDEB    ((PM_SHORT|PM_FW|PM_DXXX|PM_CH) | &H0201L)

' DTMF initiation bitmap
'Global Const DXCH_DTINITSET  ((PM_SHORT|PM_FW|PM_DXXX|PM_CH) | &H0203L)

' Delay after ring recvd before winking
'Global Const DXCH_WINKDLY    ((PM_SHORT|PM_FW|PM_DXXX|PM_CH) | &H0204L)

' Duration of wink (off-hook state)
'Global Const DXCH_WINKLEN    ((PM_SHORT|PM_FW|PM_DXXX|PM_CH) | &H0205L)

' Min LC on to be recognized as wink
'Global Const DXCH_MINRWINK   ((PM_SHORT|PM_FW|PM_DXXX|PM_CH) | &H0206L)

' Max LC on to be recognized as wink
'Global Const DXCH_MAXRWINK   ((PM_SHORT|PM_FW|PM_DXXX|PM_CH) | &H0207L)

' Length of DTMF digit for dialing
'Global Const DXCH_TTDATA     ((PM_SHORT|PM_FW|PM_DXXX|PM_CH) | &H0208L)

' Length of TT inter digit delay
'Global Const DXCH_T_IDD      ((PM_SHORT|PM_FW|PM_DXXX|PM_CH) | &H0209L)

' MF detection mask
'Global Const DXCH_MFMODE     ((PM_SHORT|PM_FW|PM_MF40|PM_CH) | &H0201L)

' Diagnostic mask
'Global Const DXCH_MFDIAG     ((PM_SHORT|PM_FW|PM_MF40|PM_CH) | &H0202L)

' Per channel dig rate: play (D/xxx only)
'Global Const DXCH_PLAYDRATE  ((PM_SHORT|PM_FW|PM_D12X|PM_CH) | &H0E01L)

' Per channel dig rate: rec (D/xxx only)
'Global Const DXCH_RECRDRATE  ((PM_SHORT|PM_FW|PM_D12X|PM_CH) | &H0E02L)

' DTMF detection edge select
'Global Const DXCH_DFLAGS     ((PM_SHORT|PM_FW|PM_DXXX|PM_CH) | &H0801L)

' Per channel ring count
Global Const DXCH_RINGCNT = ((PM_SHORT Or PM_DRV Or PM_DXXX Or PM_CH) Or &H1)

Function LoadFileData() As Integer
    Dim Ndx As Integer

    On Error Resume Next

    '   Load Confiuration File

    Err = 0
    LoadFileData = True
    Open CFGFilePath For Random Access Read Write As CFGFileNo Len = Len(CFGFileData)
    If Err = 0 Then
        If LOF(CFGFileNo) > 0 Then
            Get #CFGFileNo, 1, CFGFileData
            CFGTempData = CFGFileData
        Else
            CFGTempData.CFGApplicationText(0) = "c:\users\dialogic\bin\startcfg.exe"
            CFGTempData.CFGApplicationText(1) = StartUpDirPath & "\svserver.exe"
            CFGTempData.CFGApplicationText(2) = StartUpDirPath & "\svsplay.vox"
            CFGTempData.CFGApplicationText(3) = StartUpDirPath & "\svsrecf.vox"
            For Ndx = 0 To 3 Step 1
                If Ndx < 3 Then
                    CFGTempData.CFGSSCheckBox1(Ndx) = False
                End If
                If Ndx < 2 Then
                    CFGTempData.CFGSSCheckBox2(Ndx) = False
                    CFGTempData.CFGPhoneNumber(Ndx) = ""
                End If
            Next Ndx
            CFGTempData.CFGCaptureTextToFile = False
        End If
        Close CFGFileNo
    Else
        MsgBox "Open Error " & Str$(Err) & " , Configuration File Path = " & CFGFilePath
        LoadFileData = False
    End If
End Function




    

Sub CenterForm(TheForm As Form)

    On Error Resume Next

    TheForm.Left = (Screen.Width - TheForm.Width) / 2
    TheForm.Top = (Screen.Height - TheForm.Height) / 2
    
    DoEvents
    
End Sub

Public Sub SaveFileData()

    On Error Resume Next

    Open CFGFilePath For Random Access Write As CFGFileNo Len = Len(CFGFileData)
    CFGFileData = CFGTempData
    Put #CFGFileNo, 1, CFGFileData
    Close CFGFileNo
End Sub




Public Function ShellDialogic(AppFilePath As String) As Integer
    Dim Result
    
    On Error Resume Next
    
    '   Launch maximized with focus
    
    Err = 0
    Result = Shell(AppFilePath, 1)
    ShellDialogic = Err
    
End Function

Public Function ShellSVServer(AppFilePath As String) As Integer
    Dim Result
    
    On Error Resume Next
    
    Err.Clear
    '   To run as one thread per channel use the term MultiThread
    '   To limit the number of lines use MaxLines nn
    '   Result = Shell(Trim$(AppFilePath) & " SVSLicense, MultiThread, MaxLines " & Trim$(Str(MAXLines)), 1)
    Result = Shell(Trim$(AppFilePath) & " SVSLicense, MultiThread", 1)
    ShellSVServer = Err.Number
    MsgBox "The SVSERVER.EXE will not operate with SVSLicense... A valid authorization code is embedded in the executables.  Please run the sample applications in the EXECUTES folder.", MB_OK, ""
    
End Function

Public Sub ShellNotes()
    Dim Result As Variant
    Dim FilePath As String * 128

    On Error Resume Next

    FilePath = "notepad.exe " & StartUpDirPath & "\svssamp4\infosht4.txt"
    Result = Shell(Trim$(FilePath), 1)
    DoEvents

End Sub

Public Function CopyText() As Integer
    Dim Result As Integer
    Dim EditString As String

    On Error Resume Next

    Result = False

    If TypeOf Screen.ActiveControl Is TextBox Then Result = True
    If TypeOf Screen.ActiveControl Is ComboBox Then
        If Screen.ActiveControl.Style <> 2 Then Result = True
    End If
    If Result = True Then
        EditString = Trim$(Mid$(Screen.ActiveControl.Text, Screen.ActiveControl.SelStart + 1, Screen.ActiveControl.SelLength))
        Clipboard.SetText EditString
    End If
    CopyText = Result

End Function

Public Function CutText() As Integer
    Dim Result As Integer
    Dim EditString As String, String1 As String, String2 As String
    Dim LenEditString As Integer, LenString1 As Integer, LenString2 As Integer

    On Error Resume Next

    Result = CopyText()
    If Result = True Then
        LenEditString = Len(Trim$(Screen.ActiveControl.Text))
        EditString = Trim$(Screen.ActiveControl.Text)

        LenString1 = Screen.ActiveControl.SelStart
        String1 = Trim$(Left$(Screen.ActiveControl.Text, LenString1))
        
        LenString2 = LenEditString - (LenString1 + Screen.ActiveControl.SelLength)
        String2 = Trim$(Right$(EditString, LenString2))

        Screen.ActiveControl.Text = Trim$(String1) & Trim$(String2)
    Else
        Result = False
    End If
    CutText = Result

End Function


Public Sub EditMenuDisable()

    On Error Resume Next

    Screen.ActiveForm.CutItem.Enabled = False
    Screen.ActiveForm.CopyItem.Enabled = False
    
End Sub

Public Sub EditMenuEnable()

    On Error Resume Next

    Screen.ActiveForm.CutItem.Enabled = True
    Screen.ActiveForm.CopyItem.Enabled = True
    Screen.ActiveForm.PasteItem.Enabled = True

End Sub

Public Function PasteText()
    Dim Result As Integer
    Dim EditString As String, String1 As String, String2 As String, String3 As String
    Dim LenEditString As Integer, LenString1 As Integer, LenString2 As Integer, LenString3 As Integer

    On Error Resume Next

    Result = False

    If TypeOf Screen.ActiveControl Is TextBox Then Result = True
    If TypeOf Screen.ActiveControl Is ComboBox Then
        If Screen.ActiveControl.Style <> 2 Then Result = True
    End If
    If Result = True Then
        LenEditString = Len(Trim$(Screen.ActiveControl.Text))
        EditString = Trim$(Screen.ActiveControl.Text)

        LenString1 = Screen.ActiveControl.SelStart
        String1 = Trim$(Left$(Screen.ActiveControl.Text, LenString1))
        
        String2 = Trim$(Clipboard.GetText(1))
        LenString2 = Len(String2)

        LenString3 = LenEditString - (LenString1 + Screen.ActiveControl.SelLength)
        String3 = Trim$(Right$(EditString, LenString3))

        Screen.ActiveControl.Text = Trim$(String1) & Trim$(String2) & Trim$(String3)
    Else
        Result = False
    End If
    PasteText = Result
    
End Function


Public Sub ShellFunctionSet()
    Dim Result As Variant
    Dim FilePath As String * 128

    On Error Resume Next
    
    FilePath = "write.exe " & StartUpDirPath & "\functset.doc"
    Result = Shell(FilePath, 3)
    'MsgBox Trim$(FilePath)
    DoEvents
    
End Sub



Public Sub ShellTextFile()
    Dim Result As Variant
    Dim FilePath As String * 128

    On Error Resume Next

    FilePath = Trim$("notepad.exe " & StartUpDirPath & "\svssamp4\svssamp4.txt")
    Result = Shell(Trim$(FilePath), 1)
    DoEvents
    
End Sub

Public Sub ShellOrderForm()
    Dim Result As Variant
    Dim FilePath As String * 128

    On Error Resume Next
    
    FilePath = "write.exe " & StartUpDirPath & "\svsorder.wri"
    Result = Shell(FilePath, 3)
    
    DoEvents
End Sub
